camera = {}
camera.x = 0
camera.y = 0
camera.xvel = 0
camera.yvel = 0
camera.scaleX = 0.33
camera.scaleY = 0.33
camera.speed = 10
camera.rotation = 0
camera.zoom = 0.27
camera.xvel = 0
camera.yvel = 0

screenWidth = love.graphics.getWidth() * camera.scaleX
screenHeight = love.graphics.getHeight() * camera.scaleY
function camera:follow(dt)
    if player.x + player.width / 2 > love.graphics.getWidth() * camera.scaleX / 2 then    
      camera.x = camera.x - (camera.x - (player.x - screenWidth / 2 + player.width / 2)) * dt * camera.speed
    end
    if player.y + player.height / 2 > love.graphics.getHeight() * camera.scaleY / 2 then
      camera.y = camera.y - (camera.y - (player.y - screenHeight / 2 + player.height / 2)) * dt * camera.speed
    end
end
function camera:set2(scale)
  love.graphics.push()
  love.graphics.rotate(-self.rotation)
  love.graphics.scale(1 / scale, 1 / scale)
  love.graphics.translate(-self.x, -self.y)
end
function camera.unset2()
  love.graphics.pop()
end

function camera:set()
  love.graphics.push()
  love.graphics.rotate(-self.rotation)
  love.graphics.scale(1 / self.scaleX, 1 / self.scaleY)
  love.graphics.translate(-self.x, -self.y)
end
function camera.shake(intensity) --Harlem shake
  if player.x + 8 > screenWidth / 2 and player.x + 8 < #row * 16 - screenWidth / 2 then
    camera.xvel = intensity
  else
    camera.xvel = 0
  end
  camera.yvel = -intensity
end--Hate me
function camera:unset()
  love.graphics.pop()
end

function camera:move(dx, dy)
  self.x = self.x + (dx or 0)
  self.y = self.y + (dy or 0)
end

function camera:rotate(dr)
  self.rotation = self.rotation + dr
end

function camera:scale(sx, sy)
  sx = sx or 1
  self.scaleX = self.scaleX * sx
  self.scaleY = self.scaleY * (sy or sx)
end

function camera:setPosition(x, y)
  self.x = x or self.x
  self.y = y or self.y
end

function camera:setScale(sx, sy)
  self.scaleX = sx or self.scaleX
  self.scaleY = sy or self.scaleY
end
function camera:change_focuse(scale)
 self.scaleX = scale
 self.scaleY = scale
 love.graphics.pop()
 love.graphics.push()
 love.graphics.translate(-self.x, -self.y)
 love.graphics.scale(1/ self.scaleX, 1/ self.scaleY)
end
camera.width = love.graphics.getWidth() / 3.3

camera.layers = {}

function camera.updateVel(dt)
    camera.x = camera.x + camera.xvel * dt
    camera.y = camera.y + camera.yvel * dt

    if player.x + 8 > screenWidth / 2 and player.x + 8 < #row * 16 - screenWidth / 2 then
    
    else
      camera.xvel = 0
    end


    if camera.xvel > 0 then
      camera.xvel = camera.xvel - camera.speed + 0 * dt
    end
    if camera.xvel < 0 then
      camera.xvel = camera.xvel + camera.speed + 0 * dt
    end
    if camera.yvel > 0 then
      camera.yvel = camera.yvel - camera.speed + 0 * dt
    end
    if camera.yvel < 0 then
      camera.yvel = camera.yvel + camera.speed + 0 * dt
    end
end


function camera:newLayer(scale, func)
  table.insert(self.layers, { draw = func, scale = scale })
  table.sort(self.layers, function(a, b) return a.scale < b.scale end)
end

function camera:draw()
  local bx, by = self.x, self.y
  
  for _, v in ipairs(self.layers) do
    self.x = bx * v.scale
    self.y = by * v.scale
    camera:set()
    v.draw()
    camera:unset()
  end
end











