
local gui_table = {}
local gui_scale = 4
local gui_pop_time = .3

gui_panel = {}

function gui_panel:new(x,y,image_file,key)
	local panel = {
		x = x,
		y = y,
		key = key,
		active = nil,
		active_timer = 0,
		gui_image = love.graphics.newImage(image_file),
		
		}
	setmetatable(panel, self)
	self.__index = self
	return panel
end

function gui_panel:pop_panel()
		if self.active_timer >= gui_pop_time then
			self.active = nil
		elseif  self.active_timer <= 0 then
			self.active = true
		end
end
function gui_panel:update_panel(dt)
	if self.active and self.active_timer < gui_pop_time then
		self.active_timer = self.active_timer + dt
	end
	if not self.active and self.active_timer > 0 then
		self.active_timer = self.active_timer - dt
	end
	if self.active_timer > gui_pop_time then
		self.active_timer = gui_pop_time
	elseif  self.active_timer < 0 then
		self.active_timer = 0
	end
end
function gui_panel:draw_panel()
	if self.active_timer > 0 then
		self.gui_image:setFilter('nearest','nearest')
		local adjusted_scale = self.gui_image:getWidth()*gui_scale
		local pop_mod = ((self.active_timer/gui_pop_time/1)*adjusted_scale)-adjusted_scale
		love.graphics.draw(self.gui_image,self.x+pop_mod,self.y,0,gui_scale,gui_scale)
		love.graphics.setColor(0,0,0,255)
		-- printing stuff will go here
		love.graphics.setColor(255,255,255,255)
	end
end

function gui_new_panel(x,y,image_file,key,toggle)
	local temp_panel = gui_panel:new(x,y,image_file,key,toggle)
	table.insert(gui_table, temp_panel)
	
end

function gui_update(dt)
	for i,v in ipairs(gui_table) do
		if love.keyboard.isDown(v.key) then
			v:pop_panel()
		end
		
		v:update_panel(dt)
		
	end
end

function gui_draw()
	for i,v in ipairs(gui_table) do
		v:draw_panel()
		
	end

end