require "menu"
require "camera"
require "player_images"
require "player"
require "npc"
require "gui"

function love.load()
	

	--Fonts--
	small = love.graphics.newFont(27)
	medium = love.graphics.newFont(37)
	large = love.graphics.newFont(57)
	--     --


	--Background Color
	love.graphics.setBackgroundColor(255,255,255)


	--GAMESTATE--
	gamestate = 'playing'
	--gamestate = 'menu'
	--         --

	--BUTTONS--
	action_button = 'c'

	--Loading Classes--
	player.load()
	--               --
	gui_new_panel(0,175,"images/interface/menuBlock.png","x",0)
	gui_new_panel(0,65,"images/interface/healthBlock.png","z",0)
	npc.spawn(50,50,1)
	
end
function love.update(dt)
	filter_playerImage()
	if gamestate == 'menu' then
		--If the game is in the menu
		UPDATE_BUTTON(dt)
	end
	if gamestate == 'playing' then
		UPDATE_PLAYER(dt)
		UPDATE_NPC(dt)

		camera:follow(dt)
	end
	gui_update(dt)
end
function love.keypressed(key)
	if gamestate == 'playing' then
		KEY_NPC(key)
	end
end
function love.draw()
	camera:set()
	if gamestate == 'menu' then
		--If the game is in the menu
		DRAW_BUTTON()
	end
	if gamestate == 'playing' then
		--If the game is playing
		DRAW_NPC()
		DRAW_PLAYER()
	end
	camera:unset()
	gui_draw()
end



