--[[Player Class]]--
--LOAD
--DRAW
--BOUNDARY

local framerate = 0.083


function player.load()
	--Pos
	player.x = 5
	player.y = 5

	--Colors
	player.red = 255
	player.green = 255
	player.blue = 255

	--Movment
	player.speed = 33
	player.movement = true
	player.pic = 1

	--Animation
	player.dir = 'right'
	player.animtimer = 0
	player.shadow = love.graphics.newImage('images/effects/playerShadow.png')
		player.shadow:setFilter('nearest','nearest')

	player.width = player.picR[1]:getWidth()
	player.height = player.picR[1]:getHeight()
end
--





function player.draw()
	--Shadow
	love.graphics.setColor(255,255,255)
	love.graphics.draw(player.shadow,player.x + player.width / 2 - player.shadow:getWidth() / 2,player.y + player.picR[1]:getHeight() - 3.5)


	--Draw the player!
	love.graphics.setColor(player.red,player.green,player.blue)
	if player.dir == 'down' then
		love.graphics.draw(player.picD[player.pic],player.x,player.y)
	end
	if player.dir == 'downright' then
		love.graphics.draw(player.picDR[player.pic],player.x,player.y)
	end
	if player.dir == 'downleft' then
		love.graphics.draw(player.picDL[player.pic],player.x,player.y)
	end
	if player.dir == 'up' then
		love.graphics.draw(player.picU[player.pic],player.x,player.y)
	end
	if player.dir == 'upleft' then
		love.graphics.draw(player.picUL[player.pic],player.x,player.y)
	end
	if player.dir == 'upright' then
		love.graphics.draw(player.picUR[player.pic],player.x,player.y)
	end
	if player.dir == 'right' then
		love.graphics.draw(player.picR[player.pic],player.x,player.y)
	end
	if player.dir == 'left' then
		love.graphics.draw(player.picL[player.pic],player.x,player.y)
	end
end
--
function player.boundary()
	--Limiting his movement
	if player.x < 0 then
		player.x = 0
	end
	if player.y < 0 then
		player.y = 0
	end
end
--
function player.move(dt)
	--Movement and direction assignment

	--Up, and up diagnol
	if love.keyboard.isDown('up') then
		--Straight up
		if not love.keyboard.isDown('right') and not love.keyboard.isDown('left') then
			player.dir = 'up'
			player.y = player.y - player.speed * dt
		end
		--Up left
		if not love.keyboard.isDown('right') and love.keyboard.isDown('left') then
			player.dir = 'upleft'
			player.y = player.y - player.speed * dt
			player.x = player.x - player.speed * dt
		end
		--Up right
		if not love.keyboard.isDown('left') and love.keyboard.isDown('right') then
			player.dir = 'upright'
			player.y = player.y - player.speed * dt
			player.x = player.x + player.speed * dt
		end
	end
	--DOwn, and down diagonal
	if love.keyboard.isDown('down') then
		--Straight down
		if not love.keyboard.isDown('right') and not love.keyboard.isDown('left') then
			player.dir = 'down'
			player.y = player.y + player.speed * dt
		end
		--Down right
		if not love.keyboard.isDown('left') and love.keyboard.isDown('right') then
			player.dir = 'downright'
			player.y = player.y + player.speed * dt
			player.x = player.x + player.speed * dt
		end

		if not love.keyboard.isDown('right') and love.keyboard.isDown('left') then
			player.dir = 'downleft'
			player.y = player.y + player.speed * dt
			player.x = player.x - player.speed * dt
		end
	end
		--Horizontal
			--right
			if love.keyboard.isDown('right') and not love.keyboard.isDown('up') and not love.keyboard.isDown('down') then
					player.dir = 'right'
					player.x = player.x + player.speed * dt
			end
			--left
			if love.keyboard.isDown('left') and not love.keyboard.isDown('up') and not love.keyboard.isDown('down') then
				player.dir = 'left'
				player.x = player.x - player.speed * dt
			end
end
--
function player.animate(dt)
	--Animate the player!
	if love.keyboard.isDown('right') or love.keyboard.isDown('left') or love.keyboard.isDown('down') or love.keyboard.isDown('up') then --If you are moving the player at all.
		player.animtimer = player.animtimer + dt
		if player.animtimer > framerate then
			if player.pic < #player.picR then
				player.pic = player.pic + 1
			end
			if player.pic == #player.picR then
				player.pic = 1
			end
			player.animtimer = 0
		end
	end
	if not love.keyboard.isDown('right') and not love.keyboard.isDown('left') and not love.keyboard.isDown('down') and not love.keyboard.isDown('up') then
		player.animtimer = 0
		player.pic = 1
	end
end







--PARENT FUNCTIONS
function DRAW_PLAYER()
	player.draw()
end
function UPDATE_PLAYER(dt)
	player.animate(dt)
	if player.movement == true then --For things like talking to npc's 
		player.move(dt)
	end
end









